import random 
class Jeu :
    def __init__( self, m=None ):
        if not m is None:
            if 0 <= m <= 1000: 
                self.m = m
            else:
                raise ValueError("Parmetre unvalide pour m.")
        else:
            self.m = random.randint( 0, 1000 )
    def definir_entier( m ):
        if 0 <= m <= 1000:
            self.m = m
        else:
            raise ValueError("Entier non valide. m doit etre entre 0 et 1000.")
    def proposer_solution( self, m ):
        return self.m - m
    def reponse( self ):
        return self.m

#
# Complexité :
#
#    O( m )
#    Omega( m )
#
def trouver_entier( j ):
    for i in range( 1001 ):
        if j.proposer_solution( i ) == 0:
            return i
    return None

# Tests #
if __name__ == "__main__":
    j = Jeu()
    print( "entier trouvé : " + str(trouver_entier(j)) + ", réponse : " + str(j.reponse()) )
    for m in range( 0, 1001 ) :
        j = Jeu( m )
        # on lève une assertion si l'algorithme n'est pas capable de trouver la bonne réponse
        assert( m==trouver_entier(j) )
