import random 
class Jeu :
    def __init__( self, m=None ):
        if not m is None:
            if 0 <= m <= 1000: 
                self.m = m
            else:
                raise ValueError("Parmetre unvalide pour m.")
        else:
            self.m = random.randint( 0, 1000 )
    def definir_entier( m ):
        if 0 <= m <= 1000:
            self.m = m
        else:
            raise ValueError("Entier non valide. m doit etre entre 0 et 1000.")
    def proposer_solution( self, m ):
        return self.m - m
    def reponse( self ):
        return self.m

#
# Complexité :
#
#    Si on note par n l'entier maximale (dans l'exercice n=1000)
#    alors la complexité est égale à :
# 
#    O( ln(n) )
#    Omega( ln(n) )
#
#    Si on fix n=1000, on a alors une complexité constante :
#
#    O( 1 )
#    Omega( 1 )
#
def trouver_entier( j ):
    sol_min = 0
    sol_max = 1000
    while sol_max > sol_min :
        proposition = ( sol_max + sol_min )//2
        if j.proposer_solution( proposition ) <= 0 :
            sol_max = proposition
        else:
            sol_min = proposition+1
    if j.proposer_solution( sol_max ) == 0:
        return sol_max
    else:
        return None

# Tests #
if __name__ == "__main__":
    j = Jeu()
    print( "entier trouvé : " + str(trouver_entier(j)) + ", réponse : " + str(j.reponse()) )
    for m in range( 0, 1001 ) :
        j = Jeu( m )
        # on lève une assertion si l'algorithme n'est pas capable de trouver la bonne réponse
        assert( m==trouver_entier(j) )
