#
# Complexité :
#
#    Si on pose n = len( T )
# 
#    O( n )
#    Omega( 1 )
#
#   Meilleur cas : L'element e est en première position
#   Pire cas : L'élément e n'est pas dans le tableau
#
def rechercher_element( T, e ):
    if len(T) == 0 :
        return -1
    id_min = 0
    id_max = len( T ) - 1
    while id_min < id_max :
        proposition = ( id_min + id_max )//2
        if T[proposition] >= e:
            id_max = proposition
        else:
            id_min = proposition + 1
    if T[id_min] == e :
        return id_min
    return -1

# Tests #
if __name__ == "__main__":
    import outils
    e = 3
    T = outils.creer_tableau_trie( 5, 0, 10 )
    print( "T : " + str(T) + ", e : " + str(e) + ", index : " + str( rechercher_element( T, e ) ) )
    T = outils.creer_tableau_trie( 10, 0, 10 )
    print( "T : " + str(T) + ", e : " + str(e) + ", index : " + str( rechercher_element( T, e ) ) )
    T = outils.creer_tableau_trie( 20, 0, 10 )
    print( "T : " + str(T) + ", e : " + str(e) + ", index : " + str( rechercher_element( T, e ) ) )
    T = outils.creer_tableau_trie( 20, 0, 10 )
    print( "T : " + str(T) + ", e : " + str(e) + ", index : " + str( rechercher_element( T, e ) ) )
    T = outils.creer_tableau_trie( 20, 0, 10 )
    print( "T : " + str(T) + ", e : " + str(e) + ", index : " + str( rechercher_element( T, e ) ) )
