import timeit
import outils
import time

def pires_cas( n ):
    return [ list( range(n-1, -1, -1) ) ]

def meilleurs_cas(n ):
    return [ list( range(n) ) ]

def cas_aleatoires(n, nb_cas):
    res = []
    for i in range(nb_cas):
        res.append( outils.creer_tableau(n, 0, 20) ) 
    return res

def quelques_cas( n, nb_cas ):
    p = pires_cas(n)
    m = meilleurs_cas(n)
    if( nb_cas-len(m)-len(p) >= 0):
        return p + cas_aleatoires( n, nb_cas-len(m)-len(p) ) + m
    return p + m


def initialisation( cas ):
    return """
import exercice_12
tableaux = %s
"""%(str(cas))

def programme( n ):
    return """
exercice_12.rechercher_element( tableaux[%d], 0 )
"""%(n)


temps = {}
for n in range(100):
    temps[n] = []
    nb_cas = 30
    cas = quelques_cas(n, nb_cas)
    init = initialisation(cas)
    for i in range( len(cas) ):
        repeat = 100
        nb = 10
        temps[n].append(
            min(
                timeit.repeat(
                    programme(i), init, 
                    repeat=repeat, # Nb de fois que 
                                   # intitialisation(n) + number X programme(n) est 
                                   # execut\'e
                    number=nb, #Nb de fois que le programme(n) est execut\'e
                    timer=time.process_time
                )
            )/nb
        )

if __name__ == "__main__":
    outils.draw_points( temps )
